<?php
/**
 *
 * @package RelatedTopics
 * @license http://madjoki.com/smf-mods/license/ New-BSD
 *
 * Converted to ElkArte:
 * @convertor  	ahrasis ahrasis@gmail http://elkarte.sch.my (ElkArte Version)
 *
 */

if (!defined('ELK'))
	die('No access...');

// Main funtions
function loadRelated($topic)
{
	global $modSettings, $context;
	$db = database();

	$context['can_approve_posts_boards'] = boardsAllowedTo('approve_posts', false);

	// Otherwise use customized fulltext index
	$request = $db->query('', '
		SELECT IF(rt.id_topic_first = {int:topic}, rt.id_topic_second, rt.id_topic_first) AS id_topic
		FROM {db_prefix}related_topics AS rt
			JOIN {db_prefix}topics AS t ON (t.id_topic = IF(rt.id_topic_first = {int:topic}, rt.id_topic_second, rt.id_topic_first))
			JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
		WHERE (id_topic_first = {int:topic} OR id_topic_second = {int:topic})
			AND {query_see_board}
		ORDER BY rt.score DESC
		LIMIT {int:limit}',
		array(
			'topic' => $topic,
			'limit' => $modSettings['relatedTopicsCount'],
		)
	);

	if ($db->num_rows($request) == 0)
	{
		$db->free_result($request);

		return false;
	}

	$topics_ids = array();
	while ($row = $db->fetch_assoc($request))
		$topics_ids[] = $row['id_topic'];
	$db->free_result($request);

	return prepareTopicArray($topics_ids);
}

function prepareTopicArray($topic_ids)
{
	global $scripturl, $txt, $db_prefix, $modSettings, $options, $context;
	global $user_info, $board_info, $settings;
	$db = database();

	// Setup the default topic icons...
	$stable_icons = array('xx', 'thumbup', 'thumbdown', 'exclamation', 'question', 'lamp', 'smiley', 'angry', 'cheesy', 'grin', 'sad', 'wink', 'moved', 'recycled', 'wireless');
	$context['icon_sources'] = array();
	foreach ($stable_icons as $icon)
		$context['icon_sources'][$icon] = 'images_url';

	if (empty($topic_ids))
		return false;
	
	$context['messages_per_page'] = empty($modSettings['disableCustomPerPage']) && !empty($options['messages_per_page']) && !WIRELESS ? $options['messages_per_page'] : $modSettings['defaultMaxMessages'];

	$result = $db->query('substring', '
		SELECT
			t.id_topic, t.num_replies, t.locked, t.num_views, t.is_sticky, t.id_poll, t.id_previous_board,
			' . ($user_info['is_guest'] ? '0' : 'IFNULL(lt.id_msg, IFNULL(lmr.id_msg, -1)) + 1') . ' AS new_from,
			t.id_last_msg, t.approved, t.unapproved_posts, ml.poster_time AS last_poster_time,
			ml.id_msg_modified, ml.subject AS last_subject, ml.icon AS last_icon,
			ml.poster_name AS last_member_name, ml.id_member AS last_id_member,
			IFNULL(meml.real_name, ml.poster_name) AS last_display_name, t.id_first_msg,
			mf.poster_time AS first_poster_time, mf.subject AS first_subject, mf.icon AS first_icon,
			mf.poster_name AS first_member_name, mf.id_member AS first_id_member,
			IFNULL(memf.real_name, mf.poster_name) AS first_display_name, SUBSTRING(ml.body, 1, 385) AS last_body,
			SUBSTRING(mf.body, 1, 385) AS first_body, ml.smileys_enabled AS last_smileys,
			mf.smileys_enabled AS first_smileys, b.id_board, b.name As board_name
		FROM {db_prefix}topics AS t
			INNER JOIN {db_prefix}boards AS b ON (b.id_board = t.id_board)
			INNER JOIN {db_prefix}messages AS ml ON (ml.id_msg = t.id_last_msg)
			INNER JOIN {db_prefix}messages AS mf ON (mf.id_msg = t.id_first_msg)
			LEFT JOIN {db_prefix}members AS meml ON (meml.id_member = ml.id_member)
			LEFT JOIN {db_prefix}members AS memf ON (memf.id_member = mf.id_member)' . ($user_info['is_guest'] ? '' : '
			LEFT JOIN {db_prefix}log_topics AS lt ON (lt.id_topic = t.id_topic AND lt.id_member = {int:current_member})
			LEFT JOIN {db_prefix}log_mark_read AS lmr ON (lmr.id_board = t.id_board AND lmr.id_member = {int:current_member})'). '
		WHERE t.id_topic IN ({array_int:topic_list})
			AND (t.approved = {int:is_approved}' . ($user_info['is_guest'] ? '' : ' OR t.id_member_started = {int:current_member}') . ')',
		array(
			'current_member' => $user_info['id'],
			'topic_list' => $topic_ids,
			'is_approved' => 1,
		)
	);

	// Stolen from SMF
	// Begin 'printing' the message index for current board.
	while ($row = $db->fetch_assoc($result))
	{
		if ($row['id_poll'] > 0 && $modSettings['pollMode'] == '0')
			continue;

		$topic_ids[] = $row['id_topic'];

		// Does the theme support message previews?
		if (!empty($modSettings['preview_characters']))
		{
			// Limit them to $modSettings['preview_characters'] characters
			$row['first_body'] = strip_tags(strtr(parse_bbc($row['first_body'], $row['first_smileys'], $row['id_first_msg']), array('<br>' => '&#10;')));
			if ($db->strlen($row['first_body']) > $modSettings['preview_characters'])
				$row['first_body'] = $db->substr($row['first_body'], 0, $modSettings['preview_characters']) . '...';

			$row['last_body'] = strip_tags(strtr(parse_bbc($row['last_body'], $row['last_smileys'], $row['id_last_msg']), array('<br>' => '&#10;')));
			if ($db->strlen($row['last_body']) > $modSettings['preview_characters'])
				$row['last_body'] = $db->substr($row['last_body'], 0, $modSettings['preview_characters']) . '...';

			// Censor the subject and message preview.
			censorText($row['first_subject']);
			censorText($row['first_body']);

			// Don't censor them twice!
			if ($row['id_first_msg'] == $row['id_last_msg'])
			{
				$row['last_subject'] = $row['first_subject'];
				$row['last_body'] = $row['first_body'];
			}
			else
			{
				censorText($row['last_subject']);
				censorText($row['last_body']);
			}
		}
		else
		{
			$row['first_body'] = '';
			$row['last_body'] = '';
			censorText($row['first_subject']);

			if ($row['id_first_msg'] == $row['id_last_msg'])
				$row['last_subject'] = $row['first_subject'];
			else
				censorText($row['last_subject']);
		}

		// Decide how many pages the topic should have.
		if ($row['num_replies'] + 1 > $context['messages_per_page'])
		{
			$pages = '&#171; ';

			// We can't pass start by reference.
			$start = -1;
			$pages .= constructPageIndex($scripturl . '?topic=' . $row['id_topic'] . '.%1$d', $start, $row['num_replies'] + 1, $context['messages_per_page'], true, false);

			// If we can use all, show all.
			if (!empty($modSettings['enableAllMessages']) && $row['num_replies'] + 1 < $modSettings['enableAllMessages'])
				$pages .= ' &nbsp;<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0;all">' . $txt['all'] . '</a>';
			$pages .= ' &#187;';
		}
		else
			$pages = '';

		// We need to check the topic icons exist...
		if (!empty($modSettings['messageIconChecks_enable']))
		{
			if (!isset($context['icon_sources'][$row['first_icon']]))
				$context['icon_sources'][$row['first_icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['first_icon'] . '.png') ? 'images_url' : 'default_images_url';
			if (!isset($context['icon_sources'][$row['last_icon']]))
				$context['icon_sources'][$row['last_icon']] = file_exists($settings['theme_dir'] . '/images/post/' . $row['last_icon'] . '.png') ? 'images_url' : 'default_images_url';
		}
		else
		{
			if (!isset($context['icon_sources'][$row['first_icon']]))
				$context['icon_sources'][$row['first_icon']] = 'images_url';
			if (!isset($context['icon_sources'][$row['last_icon']]))
				$context['icon_sources'][$row['last_icon']] = 'images_url';
		}

		if (!empty($board_info['recycle']))
			$row['first_icon'] = 'recycled';

		// 'Print' the topic info.
		$context['related_topics'][$row['id_topic']] = array(
			'id' => $row['id_topic'],
			'first_post' => array(
				'id' => $row['id_first_msg'],
				'member' => array(
					'username' => $row['first_member_name'],
					'name' => $row['first_display_name'],
					'id' => $row['first_id_member'],
					'href' => !empty($row['first_id_member']) ? $scripturl . '?action=profile;u=' . $row['first_id_member'] : '',
					'link' => !empty($row['first_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['first_id_member'] . '" title="' . $txt['profile_of'] . ' ' . $row['first_display_name'] . '" class="preview">' . $row['first_display_name'] . '</a>' : $row['first_display_name']
				),
				'time' => timeformat($row['first_poster_time']),
				'timestamp' => forum_time(true, $row['first_poster_time']),
				'subject' => $row['first_subject'],
				'preview' => $row['first_body'],
				'icon' => $row['first_icon'],
				'icon_url' => $settings[$context['icon_sources'][$row['first_icon']]] . '/post/' . $row['first_icon'] . '.png',
				'href' => $scripturl . '?topic=' . $row['id_topic'] . '.0',
				'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . '.0">' . $row['first_subject'] . '</a>'
			),
			'last_post' => array(
				'id' => $row['id_last_msg'],
				'member' => array(
					'username' => $row['last_member_name'],
					'name' => $row['last_display_name'],
					'id' => $row['last_id_member'],
					'href' => !empty($row['last_id_member']) ? $scripturl . '?action=profile;u=' . $row['last_id_member'] : '',
					'link' => !empty($row['last_id_member']) ? '<a href="' . $scripturl . '?action=profile;u=' . $row['last_id_member'] . '">' . $row['last_display_name'] . '</a>' : $row['last_display_name']
				),
				'time' => timeformat($row['last_poster_time']),
				'timestamp' => forum_time(true, $row['last_poster_time']),
				'subject' => $row['last_subject'],
				'preview' => $row['last_body'],
				'icon' => $row['last_icon'],
				'icon_url' => $settings[$context['icon_sources'][$row['last_icon']]] . '/post/' . $row['last_icon'] . '.png',
				'href' => $scripturl . '?topic=' . $row['id_topic'] . ($user_info['is_guest'] ? ('.' . (!empty($options['view_newest_first']) ? 0 : ((int) (($row['num_replies']) / $context['pageindex_multiplier'])) * $context['pageindex_multiplier']) . '#msg' . $row['id_last_msg']) : (($row['num_replies'] == 0 ? '.0' : '.msg' . $row['id_last_msg']) . '#new')),
				'link' => '<a href="' . $scripturl . '?topic=' . $row['id_topic'] . ($user_info['is_guest'] ? ('.' . (!empty($options['view_newest_first']) ? 0 : ((int) (($row['num_replies']) / $context['pageindex_multiplier'])) * $context['pageindex_multiplier']) . '#msg' . $row['id_last_msg']) : (($row['num_replies'] == 0 ? '.0' : '.msg' . $row['id_last_msg']) . '#new')) . '" ' . ($row['num_replies'] == 0 ? '' : 'rel="nofollow"') . '>' . $row['last_subject'] . '</a>'
			),
			'is_sticky' => !empty($row['is_sticky']),
			'is_locked' => !empty($row['locked']),
			'is_redirect' => !empty($row['id_redirect_topic']),
			'is_poll' => $modSettings['pollMode'] == '1' && $row['id_poll'] > 0,
			'is_posted_in' => false,
			'is_watched' => false,
			'icon' => $row['first_icon'],
			'icon_url' => $settings[$context['icon_sources'][$row['first_icon']]] . '/post/' . $row['first_icon'] . '.png',
			'subject' => $row['first_subject'],
			'new' => $row['new_from'] <= $row['id_msg_modified'],
			'new_from' => $row['new_from'],
			'newtime' => $row['new_from'],
			'new_href' => $scripturl . '?topic=' . $row['id_topic'] . '.msg' . $row['new_from'] . '#new',
			'pages' => $pages,
			'replies' => comma_format($row['num_replies']),
			'views' => comma_format($row['num_views']),
			'approved' => $row['approved'],
			'unapproved_posts' => $row['unapproved_posts'],
		);
		if (!empty($settings['avatars_on_indexes']))
		{
			if (!empty($modSettings['gravatarOverride']))
			{
				if (!empty($modSettings['gravatarAllowExtraEmail']) && !empty($row['avatar']) && stristr($row['avatar'], 'gravatar://'))
					$image = get_gravatar_url($db->substr($row['avatar'], 11));
				else
					$image = get_gravatar_url($row['email_address']);
			}
			else
			{
				// So it's stored in the member table?
				if (!empty($row['avatar']))
				{
					if (stristr($row['avatar'], 'gravatar://'))
					{
						if ($row['avatar'] == 'gravatar://')
							$image = get_gravatar_url($row['email_address']);
						elseif (!empty($modSettings['gravatarAllowExtraEmail']))
							$image = get_gravatar_url($db->substr($row['avatar'], 11));
					}
					else
						$image = stristr($row['avatar'], 'http://') ? $row['avatar'] : $modSettings['avatar_url'] . '/' . $row['avatar'];
				}
				// Right... no avatar...
				else
					$context['topics'][$row['id_topic']]['last_post']['member']['avatar'] = array(
						'name' => '',
						'image' => '',
						'href' => '',
						'url' => '',
					);
			}
			if (!empty($image))
				$context['topics'][$row['id_topic']]['last_post']['member']['avatar'] = array(
					'name' => $row['avatar'],
					'image' => '<img class="avatar" src="' . $image . '" />',
					'href' => $image,
					'url' => $image,
				);
		}
	}
	$db->free_result($result);
}

// Helper functions
function initRelated()
{
	global $context, $modSettings;

	// Already initialized?
	if (isset($context['relatedClass']))
		return true;
	
	$context['rt_ignore'] = empty($modSettings['relatedIgnoredboards']) ? array() : explode(',', $modSettings['relatedIgnoredboards']);

	// Recycle board should be ignored by default
	if (!empty($modSettings['recycle_enable']) && !empty($modSettings['recycle_board']))
		$context['rt_ignore'][] = $modSettings['recycle_board'];
	
	// Make sure each board is only one time there
	$context['rt_ignore'] = array_unique($context['rt_ignore']);

	// No methods selected? No need to do this then
	if (empty($modSettings['relatedIndex']))
		return false;

	$context['relatedClass'] = array();

	$relatedIndexes = explode(',', $modSettings['relatedIndex']);

	foreach ($relatedIndexes as $indexType)
	{
		$indexType = ucwords($modSettings['relatedIndex']);
		$class = 'RelatedTopics' . $indexType;
		require_once(SOURCEDIR . '/addons/Subs-Related' . $indexType . '.php');
		$context['relatedClass'][] = new $class;
	}

	if (empty($context['relatedClass']))
		return false;

	return true;
}

// Update related topics
function relatedUpdateTopics($topics, $dont_remove = false)
{
	global $context;
	
	// Make sure $topics is array
	if (!is_array($topics))
		$topics = array((int) $topics);
		
	if (empty($topics))
		return;
		
	if (!isset($context['relatedClass']) && !initRelated())
		return;
	
	// First remove old related topics
	if (!$dont_remove)
		relatedRemoveTopics($topics, true);
	
	foreach ($context['relatedClass'] as $class)
		$class->updateTopics($topics);
}

// Remove related topics
function relatedRemoveTopics($topics, $only_relations = false)
{
	global $context;
	$db = database();

	// Make sure $topics is array
	if (!is_array($topics))
		$topics = array((int) $topics);
		
	if (empty($topics))
		return;
	
	// Remove topics from handlers only if its really going to be removed
	if ($only_relations)
	{
		if (!isset($context['relatedClass']) && !initRelated())
			return;
		
		foreach ($context['relatedClass'] as $class)
			$class->removeTopics($topics);
	}
		
	$db->query('', '
		DELETE FROM {db_prefix}related_topics
		WHERE id_topic_first IN({array_int:topics}) OR id_topic_second IN ({array_int:topics})',
		array(
			'topics' => $topics,
		)
	);
	
	return true;
}

// Add relation to database (called from related topic handlers)
function relatedAddRelatedTopic($topics, $source = '')
{
	$db = database();
	
	if (empty($topics))
		return false;
	
	$rows = array();
	
	foreach ($topics as $id_topic_1)
	{
		list ($id_topic_1, $id_topic_2, $score) = $id_topic_1;
		
		$rows[] = array(min($id_topic_1, $id_topic_2), max($id_topic_1, $id_topic_2), $score);
	}

	$db->insert('replace',
		'{db_prefix}related_topics',
		array('id_topic_first' => 'int', 'id_topic_second' => 'int', 'score' => 'float',),
		$rows,
		array('id_topic_first', 'id_topic_second')
	);
}

?>